# YearProgressBar

[![npm version](https://img.shields.io/npm/v/ypb?style=flat-square)](https://www.npmjs.com/package/ypb)
[![install size](https://packagephobia.com/badge?p=ypb&style=flat-square)](https://packagephobia.com/result?p=ypb)
[![license](https://img.shields.io/github/license/rdwz/yearprogbar?style=flat-square)](https://github.com/rdwz/yearprogbar)
[![style: ts-standard](https://badgen.net/badge/style/ts-standard/f3df49)][ts-standard]

> Meta's Threads bot that posts current year progress bar updates.

**_See it in action on [@yearprogbar](https://www.threads.net/@yearprogbar) 🙌_**

## Highlights

- Written in TypeScript
- Uses [Reverse-Engineered Threads API](https://github.com/junhoyeo/threads-api) underneath

## Install

```sh
npm install -g ypb
```

## Usage

```sh
ypb [options]
```

### Options

- `-u, --username <username>`: threads username.
- `-p, --password <password>`: threads password.
- `-f, --force`: (optional) force post the current progress (default: false)
- `-d, --debug`: (optional) run in local, console.log only mode (default: false)
- `-V, --version`: output the version number
- `-h, --help`: display help for command

## Examples

1. Run the program:

    ```sh
    ypb -u <username> -p <password>
    ```

2. Post the current year progress when starting the program:

    ```sh
    ypb -u <username> -p <password> -f
    ```

3. Post the current year progress on start while running in debug mode:

    ```sh
    $ ypb -u <username> -p <password> -f -d

    ╭────── 25.01.2024 19:01 ──────╮
    │                              │
    │   ⌚ 2024 is 6% complete    │
    │   ▓░░░░░░░░░░░░░░░░░░░░░░░   │
    │                              │
    ╰──────────────────────────────╯
    ```

### Toolchain

- Biome <https://biomejs.dev>
- Bun <https://bun.sh>
- TS-Standard <https://www.npmjs.com/package/ts-standard>
- tsup <https://tsup.egoist.dev/>

[ts-standard]: https://standardjs.com/#typescript

## Others

- <https://www.threads.net/@yearprogress>
- <https://www.threads.net/@yearprog>
